//package ca.hivesolutions.HardwareButtons
package ca.hivesolutions.toughpad

import android.content.Context
import ca.hivesolutions.toughpad.ToughpadPlugin

import com.panasonic.toughpad.android.api.ToughpadApi;
import com.panasonic.toughpad.android.api.ToughpadApiListener;
import com.panasonic.toughpad.android.api.appbtn.AppButtonManager;
import io.reactivex.subjects.BehaviorSubject
import android.app.IntentService
import android.content.Intent
import android.os.Bundle



class HardwareButtonsSrv : IntentService {
    constructor() : super("Button Intent Handler Thread")
    var hasHardware = false
    private var initialized = false
    val buttonEvents: BehaviorSubject<String> = BehaviorSubject.create()

    override fun onHandleIntent(intent: Intent) {
        if (intent.getAction() != AppButtonManager.ACTION_APPBUTTON) {
            return
        }
        val buttonId = intent.getIntExtra(AppButtonManager.EXTRA_APPBUTTON_BUTTON, 0)
        val buttonDown = intent.getIntExtra(AppButtonManager.EXTRA_APPBUTTON_STATE, 0)
//        val down = intent.getIntExtra(AppButtonManager.EXTRA_APPBUTTON_STATE, 0) == AppButtonManager.EXTRA_APPBUTTON_STATE_DOWN
//        println("<"+buttonId.toString()+" - "+down.toString()+">")

        val localIntent = Intent("BUTTON_EVENT")
        localIntent.action = "BUTTON_EVENT"
        localIntent.putExtra("buttonId", buttonId)
        localIntent.putExtra("buttonDown", buttonDown xor 1)
        localIntent.flags = Intent.FLAG_INCLUDE_STOPPED_PACKAGES
        getApplicationContext().sendBroadcast(localIntent)
    }
}
